'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HelperScript = undefined;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _script = require('./script');

var _script2 = _interopRequireDefault(_script);

var _partial = require('lodash/partial');

var _partial2 = _interopRequireDefault(_partial);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * HelperScript assets are the scripts which get used
 * as skypager helpers.
 *
 * - actions
 * - importers
 * - exporters
 * - plugins
 * - models
 * - renderers
 *
*/

var GroupNames = ['actions', 'exporters', 'importers', 'models', 'plugins', 'renderers'];

var HelperScript = exports.HelperScript = (function (_Script) {
  (0, _inherits3.default)(HelperScript, _Script);

  function HelperScript() {
    (0, _classCallCheck3.default)(this, HelperScript);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(HelperScript).apply(this, arguments));
  }

  (0, _createClass3.default)(HelperScript, [{
    key: 'register',

    /**
     * Loads this helper into the registry.
     *
     * This method will ensure that the DSL methods a particular type
     * of helper may rely on to generate the interface definition are
     * in scope for the script.
     */
    value: function register() {
      var host = arguments.length <= 0 || arguments[0] === undefined ? this.registry : arguments[0];

      if (host && !this.isLoader) {
        host.load(require(this.paths.absolute), {
          id: this.helperId,
          uri: this.paths.absolute
        });
      } else if (host && this.isLoader) {
        host.runLoader(require(this.paths.absolute));
      }
    }
  }, {
    key: 'uri',
    get: function get() {
      var absolute = this.paths.absolute;

      return absolute.match(/^\//) ? absolute : this.collection.root + '/' + absolute;
    }
  }, {
    key: 'helperId',
    get: function get() {
      return this.id.replace(this.groupName + '/', '');
    }
  }, {
    key: 'isLoader',
    get: function get() {
      return this.depth === 1 && this.isIndex;
    }
  }, {
    key: 'registry',
    get: function get() {
      return this.project ? this.project.get('registries.' + this.groupName) : _index2.default.registries[this.groupName];
    }
  }], [{
    key: 'decorateCollection',

    /**
     * Creates shortcuts on the helpers collection
     * for accessing the different types of helpers by group name.
     * e.g. actions, models, exporters
    */
    value: function decorateCollection(collection) {
      var scope = (0, _partial2.default)(buildScope, collection);

      GroupNames.forEach(function (groupName) {
        scope(groupName, function () {
          return collection.where(function (s) {
            return s.groupName === groupName && !s.isLoader;
          });
        });
      });

      scope('registryLoaders', function () {
        return collection.where(function (script) {
          return script.depth === 1 && script.uri.match(/index.js$/);
        });
      });

      Object.defineProperty(collection, 'compiledPath', {
        enumerable: false,
        configurable: true,
        get: function get() {
          return collection.paths.absolute.replace(/\/src/, '/lib');
        }
      });
    }
  }]);
  return HelperScript;
})(_script2.default);

exports.default = HelperScript;

function buildScope(collection, name, get) {
  (0, _defineProperty2.default)(collection, name, {
    enumerable: false,
    configurable: false,
    get: get
  });
}