export function AssetManifest(options = {}){
  let project = options.project = options.project || this

  if (options.project && !options.asset) {
    let re = ProjectExporter.call(options.project, options)
    return re
  }

  if (options.asset) {
    return AssetExporter.call(options.asset, options)
  }

}

function ProjectExporter(options = {}){
  let project = options.project

  return project.mapCollections((c) => {
    return c.transform(
      (result = {}, asset) => {
        result[ asset.paths.projectRequire ] = AssetExporter({asset})
        return result
      }
    )
  })
}

function AssetExporter(options = {}){
  let asset = options.asset || this

  const pick = require('../util').pick
  const lodashify = require('../util').lodashify(
    'pick', 'pickBy', 'omit', 'omitBy', 'get', 'set', 'keys', 'values'
  )

  asset.readSync()

  return lodashify(
    pick(asset, 'id', 'uri', 'fingerprint', 'loaderString', 'paths')
  )
}

export default AssetManifest
